#include "stdafx.h"
#include "test_funcs.h"
#include <scpl/Chain.h>
#include "CountStruct.h"

using namespace scpl;

typedef Chain<CountStruct> CSChain;

void tc(){
	CSChain csc[10];
	const CSChain* ccsc = csc;

	SUT_ASSERT_EQUALS(Int,CountStruct::getCount(),10);

	SUT_ASSERT(csc[0].insertToNext(&csc[1]));
	SUT_ASSERT(csc[0].insertToNext(&csc[2]));
	SUT_ASSERT(csc[0].insertToNext(&csc[3]));
	SUT_ASSERT(csc[0].insertToNext(&csc[4]));
	SUT_ASSERT(csc[0].insertToNext(&csc[5]));
	SUT_ASSERT(csc[0].insertToPrev(&csc[6]));
	SUT_ASSERT(csc[0].insertToPrev(&csc[7]));
	SUT_ASSERT(csc[0].insertToPrev(&csc[8]));
	SUT_ASSERT(csc[0].insertToPrev(&csc[9]));

	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[5]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[4]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[3]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[2]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[1]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[6]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[7]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[8]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[9]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[0]);

	csc[4].escape();
	csc[7].escape();
	csc[1].escape();
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[5]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[3]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[2]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[6]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[8]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[9]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[0]);
	
	SUT_ASSERT(csc[7].insertToNext(&csc[0]));
	SUT_ASSERT(csc[1].insertToNext(&csc[0]));
	SUT_ASSERT(!csc[4].insertToNext(&csc[4]));
	SUT_ASSERT(!csc[4].insertToPrev(&csc[4]));
	SUT_ASSERT(csc[4].insertToPrev(&csc[0]));
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[5]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[3]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[2]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[6]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[8]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[9]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[7]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[1]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[4]);
	ccsc = ccsc->next();SUT_ASSERT_EQUALS(Ptr,ccsc,&csc[0]);
	SUT_ASSERT_EQUALS(Int,CountStruct::getCount(),10);
}

void test_Chain(){
	tc();
	SUT_ASSERT_EQUALS(Int,CountStruct::getCount(),0);
}